#include <stdio.h>
#include <string.h>
#include <GL/glut.h>
#include "glprintf.h"

/* font12 is 96 characters starting at ' ', and is 12x24 */
/* extern unsigned char **font12; */
#include "font12.c"
#define LETTERS 98
#define LETTER_BYTES 48

static GLubyte halftone[] = {
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55,
        0xAA, 0xAA, 0xAA, 0xAA, 0x55, 0x55, 0x55, 0x55};


GLuint makefont()
{
	int i;
	unsigned char *font_index;
	GLuint baselist;
	
	baselist = glGenLists(LETTERS);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	for (i = 0 ; i < LETTERS ; i++)
	{
		/* printf("compiling letter [%c]\n", i + ' '); */
		font_index = font12[0] + LETTER_BYTES * i;
		glNewList(i + baselist, GL_COMPILE);
		glBitmap(12, 24, 0.0, 0.0, 15.0, 0.0, font_index);
		glEndList();
	}
	return baselist;
	
}


void glPrintf(GLuint fontlist, char *msg, GLfloat x, GLfloat y)
{
	int i, l, ill[4];
	static char blank[200];
	float color[4],  ur[4];
	float margin;
	

	l = strlen(msg);
	if (l > 200) l = 200;

	for (i = 0 ; i < l ; i++)
		blank[i] =  127;
	
	glPushMatrix();
	glMatrixMode(GL_PROJECTION);
	glPushMatrix();
	glLoadIdentity();
	glOrtho(0.0, 1.0, 0.0, 1.0, -1.0, 1.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glGetFloatv(GL_CURRENT_COLOR, color); /* save color for text */

	glListBase(fontlist - ' '); 

	/* get dimension of text */
 	glGetIntegerv(GL_VIEWPORT, ill);
	ur[0] = x +  (float) (l * 15 ) / (float) ill[2];
	ur[1] = y +  24.0 / (float) ill[3];
	/* marginalize */
	margin = 8.0 / (float) ill[2];
	/* stipple */
	glColor4ub(0x00, 0x00, 0x00, 0x80); /*black*/
        glEnable(GL_POLYGON_STIPPLE);
        glPolygonStipple(halftone);
	glBegin(GL_QUADS);
		glVertex3f( x - margin , y - margin ,     - 0.1);
		glVertex3f( x - margin , ur[1] + margin , - 0.1);
		glVertex3f( ur[0] + margin , ur[1] + margin , - 0.1);
		glVertex3f( ur[0] + margin , y - margin ,     - 0.1);
	glEnd();
	glDisable(GL_POLYGON_STIPPLE);

	/* message */
	glColor4fv(color); /* restore color for text */
	glRasterPos2f(x, y);
	glCallLists(strlen(msg), GL_UNSIGNED_BYTE, msg);

	glMatrixMode(GL_PROJECTION);
	glPopMatrix();
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
}
